#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from functions import functions

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc8'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 8)
__CHEETAH_genTime__ = 1192883107.2947011
__CHEETAH_genTimestamp__ = 'Sat Oct 20 08:25:07 2007'
__CHEETAH_src__ = 'skeleton.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Oct 20 08:22:11 2007'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class skeleton(functions):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        functions.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def full_body(self, **KWS):



        ## CHEETAH: generated from #def full_body at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<!DOCTYPE html
PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head><title>''')
        _v = VFFSL(SL,"title",True) # '$title' on line 9, col 14
        if _v is not None: write(_filter(_v, rawExpr='$title')) # from line 9, col 14.
        write('''</title>
  <link href="static/favicon.ico" type="image/x-icon" rel="shortcut icon">
  <link rel="stylesheet" href="static/style.css" type="text/css" />
  <link rel="stylesheet" href="static/layout.css" type="text/css" media="screen" />
  <script type="text/javascript" src="static/prototype.js"></script>
  <script type="text/javascript">
var helpWin = null;
function closeWin(){
\tif (helpWin != null){
\t\tif(!helpWin.closed)
\t\t\thelpWin.close();
\t}
}

function helppopup(name){
   closeWin()
   helpWin = window.open("help?simple=true&subject="+encodeURIComponent(name), "Help",
"status, height = 300, width = 400");
   if (window.focus){helpWin.focus();}
   return false;
}

Ajax.Responders.register({
  onCreate: function(){
    if (Ajax.activeRequestCount > 0) {
       document.getElementById("loadingnotice").style.display = \'block\';
    }
  }, 
  onComplete: function(){
    if (Ajax.activeRequestCount == 0) {
      document.getElementById("loadingnotice").style.display = \'none\';
    } 
  }
});
function replaceFunc(transport) {
  try {
    d = transport.responseText.evalJSON();
  } catch (e) {
    $(\'body\').innerHTML = \'<pre>\'+transport.responseText+\'</pre>\'
    return;
  }
  for(key in d) {
    $(key).innerHTML = d[key];
  }
}

function jsFormSubmit(location, elt){
  new Ajax.Request(location, {method: \'post\', 
  parameters: Form.serialize(elt)+\'&js=true\', 
  onSuccess: replaceFunc,
  onComplete: function() {Form.enable(elt);}
  });
  Form.disable(elt);
  return false;
}

function rowFormSubmit(elt, retpage){
  new Ajax.Request(\'command\', {method: \'post\', 
  parameters: Form.serialize(elt)+\'&js=\'+retpage, 
  onSuccess: replaceFunc
  });
  return false;
}

window.onload = {
  //Fix bug with disabled elements
  $''')
        _v = 'form' # "$('form')" on line 75, col 4
        if _v is not None: write(_filter(_v, rawExpr="$('form')")) # from line 75, col 4.
        write('''.each(Form.enable);
}

</script>
</head>
<body id="body">

<div id="err">
''')
        if VFFSL(SL,"varExists",False)('error_text'): # generated from line 83, col 1
            write('''<p>STDERR:</p><pre>''')
            _v = VFFSL(SL,"error_text",True) # '$error_text' on line 84, col 20
            if _v is not None: write(_filter(_v, rawExpr='$error_text')) # from line 84, col 20.
            write('''</pre>
''')
        write('''</div>

''')
        if not VFFSL(SL,"varExists",False)('simple') or not VFFSL(SL,"simple",True): # generated from line 88, col 1
            write('''<p>[You are logged in as ''')
            _v = VFFSL(SL,"user.username",True) # '$user.username' on line 89, col 26
            if _v is not None: write(_filter(_v, rawExpr='$user.username')) # from line 89, col 26.
            write('''.]</p>

<div class="navigation">
<p><a href="list">List</a> 
''')
            if VFFSL(SL,"varExists",False)('machine'): # generated from line 93, col 1
                write('''<a href="info?machine_id=''')
                _v = VFFSL(SL,"machine.machine_id",True) # '$machine.machine_id' on line 94, col 26
                if _v is not None: write(_filter(_v, rawExpr='$machine.machine_id')) # from line 94, col 26.
                write('''">Info</a>
<a href="vnc?machine_id=''')
                _v = VFFSL(SL,"machine.machine_id",True) # '$machine.machine_id' on line 95, col 25
                if _v is not None: write(_filter(_v, rawExpr='$machine.machine_id')) # from line 95, col 25.
                write('''">Console</a>
''')
            write('''<a href="help">Help</a></p>
''')
        write('''</div>

<div id="loadingnotice" class="loadingnotice">LOADING</div>
<div id="result" class="result"></div>

''')
        _v = VFFSL(SL,"body",True) # '$body' on line 104, col 1
        if _v is not None: write(_filter(_v, rawExpr='$body')) # from line 104, col 1.
        write('''
''')
        if not VFFSL(SL,"varExists",False)('simple') or not VFFSL(SL,"simple",True): # generated from line 105, col 1
            write('''<hr />
Questions? Contact <a href="mailto:sipb-xen-dev@mit.edu">sipb-xen-dev@mit.edu</a>.
''')
        write('''</body>
</html>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_skeleton= 'writeBody'

## END CLASS DEFINITION

if not hasattr(skeleton, '_initCheetahAttributes'):
    templateAPIClass = getattr(skeleton, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(skeleton)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=skeleton()).run()


